--- src/http/ngx_http_file_cache.c.orig	Tue Dec 29 03:50:44 2009
+++ src/http/ngx_http_file_cache.c	Tue Dec 29 03:54:21 2009
@@ -783,6 +783,7 @@
 ngx_int_t
 ngx_http_cache_send(ngx_http_request_t *r)
 {
+    off_t              size;
     ngx_int_t          rc;
     ngx_buf_t         *b;
     ngx_chain_t        out;
@@ -800,13 +801,15 @@
         return NGX_HTTP_INTERNAL_SERVER_ERROR;
     }
 
-    b->file = ngx_pcalloc(r->pool, sizeof(ngx_file_t));
-    if (b->file == NULL) {
-        return NGX_HTTP_INTERNAL_SERVER_ERROR;
+    size = c->length - c->body_start;
+
+    if (size) {
+        b->file = ngx_pcalloc(r->pool, sizeof(ngx_file_t));
+        if (b->file == NULL) {
+            return NGX_HTTP_INTERNAL_SERVER_ERROR;
+        }
     }
 
-    r->header_only = (c->length - c->body_start) == 0;
-
     rc = ngx_http_send_header(r);
 
     if (rc == NGX_ERROR || rc > NGX_OK || r->header_only) {
@@ -816,13 +819,17 @@
     b->file_pos = c->body_start;
     b->file_last = c->length;
 
-    b->in_file = 1;
+    if (size) {
+       b->in_file = 1;
+       b->file->fd = c->file.fd;
+       b->file->name = c->file.name;
+       b->file->log = r->connection->log;
+    } else {
+       b->sync = 1;
+    }
+
     b->last_buf = (r == r->main) ? 1: 0;
     b->last_in_chain = 1;
-
-    b->file->fd = c->file.fd;
-    b->file->name = c->file.name;
-    b->file->log = r->connection->log;
 
     out.buf = b;
     out.next = NULL;
--- src/http/ngx_http_upstream.c.orig	Tue Dec 29 03:51:03 2009
+++ src/http/ngx_http_upstream.c	Tue Dec 29 03:52:23 2009
@@ -2950,7 +2950,7 @@
 
     r->connection->log->action = "sending to client";
 
-    if (rc == 0) {
+    if (rc == 0 && !r->cached) {
         rc = ngx_http_send_special(r, NGX_HTTP_LAST);
     }
 
